﻿(function(w) {
    //日期格式化函数
    Date.prototype.format = function (format) {
        var o = {
            "M+": this.getMonth() + 1, //month 
            "d+": this.getDate(), //day 
            "h+": this.getHours(), //hour 
            "m+": this.getMinutes(), //minute 
            "s+": this.getSeconds(), //second 
            "q+": Math.floor((this.getMonth() + 3) / 3), //quarter 
            "S": this.getMilliseconds() //millisecond 
        };
        if (/(y+)/.test(format)) {
            format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
        }

        for (var k in o) {
            if (new RegExp("(" + k + ")").test(format)) {
                format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
            }
        }
        return format;
    };

    //取日期当前月的最大天
    Date.prototype.maxDay = function() {
        var isLeapYear = (new Date(this.getYear(), 1, 29).getMonth() == 1) ? 1 : 0;
        var days = [31, 28 + isLeapYear, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

        return days[this.getMonth()];
    };

    //将当前天所在周的第几天转为中文
    Date.prototype.dayOfWeek = function() {
        var weekArray = new Array("周日", "周一", "周二", "周三", "周四", "周五", "周六");
        return weekArray[this.getDay()];
    };
    Date.prototype.DayOfWeek = function () {
        var weekArray = new Array("星期天", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六");
        return weekArray[this.getDay()];
    };
    //每天的时段
    Date.prototype.PeriodOfDay = function () {
        var periodArray = new Array("凌晨", "早上", "上午", "中午", "下午", "晚上", "深夜");
        var time = this.getHours();
        if (time >= 0 && time <= 5) return periodArray[0];
        if (time > 5 && time <= 8) return periodArray[1];
        if (time > 8 && time < 11 ) return periodArray[2];
        if (time >= 11 && time < 13) return periodArray[3];
        if (time >= 13 && time <= 18) return periodArray[4];
        if (time > 18 && time < 23 ) return periodArray[5];
        return periodArray[6];
    };
    //下一天
    Date.prototype.nextDay = function() {
        return this.AddDay(1);
    };
    //上一天
    Date.prototype.previousDay = function () {
        return this.AddDay(-1);
    };
    //按天增减（传负数表示往前多少天）
    Date.prototype.AddDay = function (days) {
        return new Date(this.valueOf() + days * 24 * 60 * 60 * 1000);
    };
    //按小时增减（传负数表示往前多少小时）
    Date.prototype.AddHour = function (hours) {
        return new Date(this.valueOf() + hours * 60 * 60 * 1000);
    };
    //判断是否是同一天
    Date.prototype.IsSameDate = function(date) {
        return this.format('yyyyMMdd') == date.format('yyyyMMdd');
    };
    //判断是否是同一日期时间
    Date.prototype.IsSameDateTime = function (date) {
        return this.format('yyyyMMdd hh:mm:ss') == date.format('yyyyMMdd hh:mm:ss');
    };
    //比较日期大小
    Date.prototype.IsLaterOf = function(date) {
        return this.valueOf() > date.valueOf();
    };

    //时间转日期
    String.prototype.ToDate = function() {
        var str = this.replace(/-/g, "/"), date = new Date(str);
        return date;
    };
    //判断字符串是否是有效的日期
    String.prototype.IsDate = function() {
        return !isNaN(Date.parse(this));
    };
    //判断字符串是否是有效的URL
    String.prototype.IsUrl = function() {
        //var strRegex = '^((https|http|ftp|rtsp|mms)?://)'
        //    + '?(([0-9a-z_!~*\'().&=+$%-]+: )?[0-9a-z_!~*\'().&=+$%-]+@)?' //ftp的user@ 
        //    + '(([0-9]{1,3}.){3}[0-9]{1,3}' // IP形式的URL- 199.194.52.184 
        //    + '|' // 允许IP和DOMAIN（域名） 
        //    + '([0-9a-z_!~*\'()-]+.)*' // 域名- www. 
        //    + '([0-9a-z][0-9a-z-]{0,61})?[0-9a-z].' // 二级域名 
        //    + '[a-z]{2,6})' // first level domain- .com or .museum 
        //    + '(:[0-9]{1,4})?' // 端口- :80 
        //    + '((/?)|' // a slash isn't required if there is no file name 
        //    + '(/[0-9a-z_!~*\'().;?:@&=+$,%#-]+)+/?)$';
        //var re = new RegExp(strRegex);

        //return re.test(this);

        return /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(this);
    };
    //判断是否手机号码
    String.prototype.IsMobile = function() {
        return /^0?1[3|4|5|7|8][0-9]\d{8}$/.test(this);
    };
    //判断是否Email
    String.prototype.IsEmail = function () {
        return /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/.test(this);
    };
    //字符串左截取
    String.prototype.Left = function (length) {
        return this.substr(0, length);
    };
    //字符串右截取
    String.prototype.Right = function (length) {
        return this.substr(this.length - length, length);
    };
    //字符串超长截取
    String.prototype.OverLength = function(maxLength) {
        if (this.length <= maxLength) return this;
        return this.Left(maxLength) + '...';
    };
    //特殊符号转全角
    String.prototype.ToSbcCase = function() {
        var rt = this;
        rt = rt.replace(/[']/g, '’');
        rt = rt.replace(/["]/g, '”');
        rt = rt.replace(/[;]/g, '；');
        rt = rt.replace(/[!]/g, '！');
        rt = rt.replace(/[=]/g, '＝');
        rt = rt.replace(/[<]/g, '《');
        rt = rt.replace(/[>]/g, '》');
        rt = rt.replace(/[.]/g, '。');
        rt = rt.replace(/[,]/g, '，');
        return rt;
    };

    //判断当前是否是微信浏览器
    w.IsWeiXinBrowser = function() {
        return window.navigator.userAgent.toLowerCase().match(/MicroMessenger/i) == 'micromessenger';
    };
})(window);